// Since XWiki 14.1, scriptaculous effects is provided as a RequireJS package
if (require.toUrl('scriptaculous/effects').indexOf('/webjars/') < 0) {
  require.config({
    paths: {
      'scriptaculous/effects': "../../../resources/js/scriptaculous/effects.js" +
        "?v=8.4.5"
    }
  });
}

define('cookie-consent', ['scriptaculous/effects'], function() {
  var CookieConsent = Class.create({
    initialize : function(settings) {
      this.settings = settings;
      //this.clearCookie('cookieConsent'); // for debugging
      if(!this.getCookie('cookieConsent')){
        this.showDisclaimer();
      }
      var resetCookiesButton = $('ResetCookies');
      if (resetCookiesButton != null) {
        resetCookiesButton.observe('click', function() {
          this.showDisclaimer();
        }.bind(this));
      }
    },

    getCookie : function(key)
    {
      var keyEquals = key + "=";
      var value     = false;

      document.cookie.split(';').invoke('strip').each(function(s){
        if (s.startsWith(keyEquals)) {
          value = unescape(s.substring(keyEquals.length, s.length));
        }
      });

    return value;
  },

    setCookie : function(key, value, days) {
      var setValue      = key + '=' + escape(new String(value));
      var setExpiration = "";

      if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days*24*60*60*1000));
        var setExpiration = "; expires=" + date.toGMTString();
      }

      var cookieString = setValue + setExpiration + ";path=/";
      document.cookie  = cookieString;
    },

    clearCookie : function(key) {
      this.setCookie(key,'',-1);
    },

    animation : function(event, element) {
      switch(this.settings.animation)
      {
        case 'none': 
          event == 'show' ? $(element).show() : $(element).hide(); break;
        case 'slide': 
          event == 'show' ? Element.blindDown(element, { duration : 1 }) : Element.blindUp(element, { duration : 1 }); break;
        case 'fade':
          event == 'show' ? Element.blindDown(element, { duration : 1 }) : Element.blindUp(element, { duration : 1 }); break;
      }
    },

    showDisclaimer : function() {
      clearLessCache();
      if (this.settings.activeCookieTypes === '') {
        return;
      }
      var activeCookieTypes = this.settings.activeCookieTypes.split(',');

      var htmlContent1 = this.settings.disclaimer1
                       + '<button class="button" role="button" name="cookieConsentHide" id="cookieConsentHide">'
                       + this.settings.buttonText
                       + '</button>'
                       + '<button class="button" role="button" name="cookieConsentConfig" id="cookieConsentConfig">'
                       + this.settings.configButtonText
                       + '</button>';

      var htmlContent2 = this.settings.disclaimer2 + '<div id="CookieSelectPane">';

      for (i = 0; i < activeCookieTypes.length; i++) {
        var element = activeCookieTypes[i];
        var label = this.settings[element + 'Label'];
        var infoBox = this.settings[element + 'InfoBox'];
        var disabled = '';
        if (element === 'necessary') {
          label = this.settings.mandatoryLabel;
          disabled = 'disabled="disabled" checked="checked"';
        }
        htmlContent2 = htmlContent2
                     + '<div class="CookieSelectButtonWrapper" title="' + infoBox + '">'
                     + '<label for="CookieButton' + label + '">'
                     + '<input id="CookieButton' + label + '" class="CookieButton" tabindex="1" ' + disabled +' type="checkbox">'
                     + label + '</label>'
                     + '</div>';
      }

      htmlContent2 = htmlContent2 + '</div><button class="button" role="button" name="cookieConsentOK" id="cookieConsentOK">OK</button>';

      var html = '<div id="cookieConsent" style="display: none;">'
               + '<div class="col-md-2"></div>'
               + '<div id="cookieConsentContent" class="col-md-8">'
               + htmlContent1
               + '</div>'
               + '<div class="col-md-2"></div>'
               + '</div>'
               + '</div>';

      $('xwikimaincontainerinner').insert( {before : html } );
      $("cookieConsentHide").observe('click', this.hideDisclaimer.bind(this, activeCookieTypes));
      $("cookieConsentConfig").addEventListener("click", function(){
        $("cookieConsentContent").innerHTML = htmlContent2;
        $("cookieConsentOK").observe('click', function() {
          for (i = 0; i < activeCookieTypes.length; i++) {
            var element = activeCookieTypes[i];
            var label = this.settings[element + 'Label'];
            if (element === 'necessary') {
              label = this.settings.mandatoryLabel;
            }
            if(!$('CookieButton' + label).checked) {
              var index = activeCookieTypes.indexOf(element);
              if (index > -1) {
                activeCookieTypes.splice(index, 1);
              }
            }
          }
          this.hideDisclaimer(activeCookieTypes);
        }.bind(this));
      }.bind(this));

      this.animation('show', 'cookieConsent');
    },

    hideDisclaimer : function(param) {
      this.setCookie('cookieConsent', 'hide', 365);
      this.setCookie('gdprSettings', param, 365);
      this.animation('hide', 'cookieConsent');
    }
  });
  return CookieConsent;
})
                                
document.observe("dom:loaded", function() {
  require(['cookie-consent'], function(CookieConsent) {
    var settings =
    {
      'type'       : "bar",
      'position'   : "bottom",
      'animation'  : "slide",
      'buttonType' : "$settings.getProperty('buttonType').value",
      'buttonText' : "I accept all Cookies",
      'configButtonText' : "Configure",
      'disclaimer1' : "<p>This site uses cookies to improve your browsing experience, to perform analytics and for advertising. By clicking <strong>I accept all Cookies<\/strong> you agree to the use of cookies on your device. If you\'d like to change your preferences please visit the <span class=\"wikilink\"><a href=\"http:\/\/www.cnj.jus.br\/xwiki\/wiki\/bnmp2\/view\/CookieConsent\/CookiePolicy\">Cookie Policy<\/a><\/span> page.<\/p>",
      'disclaimer2' : "<p>This site uses cookies to improve your browsing experience, to perform analytics and for advertising. By registering your choice of cookies and clicking <strong>OK<\/strong> you agree to the use of those cookies on your device. If you\'d like to change your preferences please visit the <span class=\"wikilink\"><a style=\"box-sizing: border-box; background-color: transparent; color: rgb(47, 164, 231); text-decoration: underline;\" href=\"http:\/\/www.cnj.jus.br\/xwiki\/wiki\/bnmp2\/view\/CookieConsent\/CookiePolicy\">Cookie Policy<\/a><\/span> page.<\/p>",
      'necessaryInfoBox' : "Necessary cookies which are mandatory and cannot be disabled",
      'preferencesInfoBox' : "Preferences cookies or trackers which are optional and enabled by default but used only to remember your preferences.",
      'statisticsInfoBox' : "Statistics related cookies or trackers which are optional and enabled by default and user to record anonymous statistics",
      'marketingInfoBox' : "Marketing or other related cookies or trackers which are optional and disabled by default and can record personal information",
      'mandatoryLabel' : "Necessary",
      'preferencesLabel' : "Preferences",
      'statisticsLabel' : "Statistics",
      'marketingLabel' : "Marketing",
      'activeCookieTypes' : "necessary,preferences,statistics,marketing"
    };
    var cookieConsent = new CookieConsent(settings);
  });
});
  function clearLessCache() {
    var cache = "true";
  }

